#include <stdio.h>
#include <stdlib.h>
#include <iostream>
#include <fstream>

#include "cpp_GPUgaussMLEv2.h"

using namespace std;

int main(){
	int NV;

	ifstream::pos_type filesize;
	int datasize;
	float * memblock;

	// parameters with input data
	int sz = 7;
	int Nfitraw = 10;
	float PSFsigma = 1;
	int iterations = 20;
	int fittype = 3;

	float * d_Parameters;
	float * d_CRLBSs; 
	float * d_LogLikelihood;

	ifstream file ("D:\\rligteringen\\gpu_localisation\\testdata.bin", ios::in|ios::binary|ios::ate);
	if (file.is_open()) {
		filesize = file.tellg();
		datasize = (int)filesize/sizeof(float);
		memblock = new float [datasize];
		file.seekg (0, ios::beg);
		file.read ((char *) memblock, filesize);
		file.close();

		cout << "The complete file content is in memory\n";

		// reserve memory of return values
		switch(fittype) {
		case 1:
			NV=NV_P;
			break;
		case 2:
		case 3:
			NV=NV_PS;
			break;
		case 4:
			NV=NV_PS2;
			break;
		}
		d_Parameters = new float [Nfitraw*NV];
		d_CRLBSs = new float [Nfitraw*NV];
		d_LogLikelihood = new float [Nfitraw];

		gpugaussmle(memblock, sz, Nfitraw, PSFsigma, iterations, fittype, d_Parameters, d_CRLBSs, d_LogLikelihood,
					10.0, 11.0, 12.0, 13.0, 14.0, 15.0, 16.0);
		// save para and check in matlab
		ofstream file ("D:\\rligteringen\\gpu_localisation\\outdata.bin", ios::out|ios::binary);
		if (file.is_open()) {
			file.write((char *) d_Parameters, sizeof(float)*Nfitraw*NV);
			file.close();
		}
		else {
			cout << "Unable to open output file\n";
		}

		delete[] memblock;
		delete[] d_Parameters;
		delete[] d_CRLBSs;
		delete[] d_LogLikelihood;
	}
	else {
		cout << "Unable to open input file\n";
		exit(1);
	}
	return 0;
}