% [d_Parameters d_CRLBs d_LogLikelihood] = 
%   GPUgaussMLE(single(data),PSFSigma,iterations,fittype,Ax,Ay,Bx,By,gamma,d,PSFSigma_y);
clear all

%  generate data
sz = 7; % previously Npixels
Nfitraw = 10; % previously Nsims
%I = [5 10 14 18 20 25 30 50 100];
I = 10;
PSFsigma = 1; % previously sigma
backg = 0;
iterations = 20; % previously iter
%fittype = 1; %x,y,bg,I
%fittype = 2; %x,y,sigma,bg,I
fittype = 3; %x,y,z
clear X Y N BG x_cr y_cr n_cr bg_cr

for ii=1:length(I)
   coords = sz/2-0.5+rand(Nfitraw,2)-.5;

   [data] = finiteGaussPSFerf(sz,PSFsigma,I,backg,coords);
   %sum(data,[],[1 2])
   ndata=noise(data,'poisson');
   clear GPUgaussMLEv2 GPUgaussMLE
   
   img = single(permute(ndata,[2 1 3]));
   fid=fopen('testdata.bin','wb');
   fwrite(fid,img,'single');
   fclose(fid);
   % If you want to compare the output of the C interface with mex interface you break here,
   %   run the test_cpp_GPUgaussMLEv2 program and continue
   
   [d_Parameters d_CRLBSs d_LogLikelihood]=mex_GPUgaussMLEv2(img,single(PSFsigma),iterations,fittype,10.0,11.0,12.0,13.0,14.0,15.0,16.0);
  
   fid=fopen('outdata.bin','rb');
   [andwereback, count] = fread(fid,inf,'single');
   x_extern=andwereback(1:Nfitraw);
   y_extern=andwereback(Nfitraw+1:2*Nfitraw);
   fclose(fid);
   
   x=d_Parameters(:,1);
   y=d_Parameters(:,2);
   % If you want to compare the output of the C interface with the mex interface you stop here
   n=d_Parameters(:,3);
   bg=d_Parameters(:,4);
   s=d_Parameters(:,5);
   lax=d_CRLBSs(:,1);
   
   %plot(n)
   mask = n>0;
   mask = mask & (n<5*I(ii));
   %mask = mask & (n>1/5*I(ii));
   %sum(mask)
   %mask = n|1;
   Xin = coords(:,1);
   Yin = coords(:,2);
   X(ii).fit = std(x(mask)-Xin(mask));
   Y(ii).fit = std(y(mask)-Yin(mask));
   N(ii).fit = sqrt(sum((n(mask)-I(ii)).^2)/sum(mask));
   BG(ii).fit = sqrt(sum((bg(mask)-backg).^2)/sum(mask));
   X(ii).rep = mean(sqrt(lax(mask)));

   %theory
   [crlb] = fisherInformationGauss(sz,PSFsigma,I(ii),backg);
   x_cr(ii)=crlb(1,1)^.5;
   y_cr(ii)=crlb(2,2)^.5;
   n_cr(ii)=crlb(3,3)^.5;
   bg_cr(ii)=crlb(4,4)^.5;
end

%fprintf('x fit, x theo [px]: %f %f \n', X.fit, x_cr);
%fprintf('y fit, y theo [px]: %f %f \n', Y.fit, y_cr);
%fprintf('I fit, I theo [px]: %f %f \n', N.fit, n_cr);
%fprintf('B fit, B theo [px]: %f %f \n', BG.fit, bg_cr);

figure
semilogx(I,[X(:).fit]','o-')
hold on
loglog(I,[X(:).rep]','x-')
semilogx(I,x_cr,'g')
hold off
legend('found crlb','predicted crlb','theo crlb')
xlabel('photon count')
ylabel('loc uncertainty [px]')
